<template>
  <div class="revision-container p-3">
    <h6>
      <strong> {{ title }}</strong>
    </h6>
    <p>
      <strong>{{ publicationText }}</strong>
      {{ date }}
    </p>
    <div class="ec-sort mr-md-2 mt-0 mt-md-3 dropdown-container">
      <p>{{ otherVersionText }}:</p>
      <div
        class="col-right mr-2 d-inline"
        role="group"
        aria-label="Sort Dropdown"
      >
        <div class="btn-group ec-sort-dropdown" role="group">
          <button
            class="colorPrimarySort value-display list-group-item col w-100 d-flex flex-row justify-content-md-between p-0 align-items-center"
            type="button"
            @click="toggleDropdown"
          >
            <div class="pl-2 h-100 d-flex align-items-center">
              {{ selectedLabel }}
            </div>
            <div class="ecl-select__icon ecl-select__icon-Sort">
              <svg
                class="ecl-icon ecl-icon--s ecl-icon--rotate-180 ecl-select__icon-shape"
                focusable="false"
                aria-hidden="true"
              >
                <use
                  xlink:href="../../assets/img/ecl/icons.svg#corner-arrow"
                ></use>
              </svg>
            </div>
          </button>
          <ul
            class="dropdown-menu ec-ds-dropdown-items"
            :class="{ show: dropdownVisible }"
          >
            <li v-for="option in options" :key="option.value">
              <button class="dropdown-item" @click="onSelectionChange(option)">
                {{ option.label }}
              </button>
            </li>
          </ul>
        </div>
      </div>
      <!-- <router-link
        :to="{
          name: 'DatasetDiffDetails',
        }"
      >
        Compare Revisions >
      </router-link> -->
      <button
        class="p-0 ecl-button show-more row text-primary w-50 mt-2"
        @click="navigateToDatasetDiffDetails"
      >
        <span data-v-9aa62744="" class="ecl-button__label" data-ecl-label="true"
          >Compare Revision</span
        >
      </button>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType, ref, computed } from "vue";
import { useI18n } from "vue-i18n";
import { useRouter } from "vue-router";

export const DatasetRevisionContainer = defineComponent({
  name: "DatasetRevisionContainer",
  props: {
    title: {
      type: String,
      required: true,
    },
    date: {
      type: String,
      required: false,
    },
    selectedItem: {
      type: Array as PropType<{ label: string; value: string }[]>,
      required: true,
    },
    options: {
      type: Array as PropType<{ label: string; value: string }[]>,
      required: true,
    },
    modelValue: {
      type: String,
      required: true,
    },
  },
  emits: ["update:modelValue"],
  setup(props, { emit }) {
    const router = useRouter();
    const dropdownVisible = ref(false);
    const selectedLabel = ref(
      props.options.find((option) => option.value == props.modelValue)?.label ||
        ""
    );

    const selectedItem = ref([
      { label: "Version 3 - 01.01.2023", value: "3" },
      { label: "Version 2 - 25.12.2022", value: "2" },
      { label: "Version 1 - 15.12.2022", value: "1" },
    ]);
    const toggleDropdown = () => {
      dropdownVisible.value = !dropdownVisible.value;
    };

    const onSelectionChange = (option: { label: string; value: string }) => {
      selectedLabel.value = option.label;
      emit("update:modelValue", option.value);
      dropdownVisible.value = false;
    };

    const { t, te } = useI18n();

    const publicationText = computed(() => {
      return te("message.metadata.datasetRevision.publication")
        ? t("message.metadata.datasetRevision.publication")
        : "Publication";
    });
    const otherVersionText = computed(() => {
      return te("message.metadata.datasetRevision.otherVersion")
        ? t("message.metadata.datasetRevision.otherVersion")
        : "Other versions";
    });
    const oldVersion = JSON.stringify(
      {
        "@id": "https://piveau.io/set/data/test-dataset-ttl-1/null/differences",
        "dct:description": {
          "@language": "en",
          "@value": "Description of a Dataset changed ",
        },
        "rdf:description":
          "Triples in current dataset version but not in revision 1",
      },
      null,
      2
    );

    const newVersion = JSON.stringify(
      {
        "@id": "https://piveau.io/set/data/test-dataset-ttl-1/1/differences",
        "dct:description": {
          "@language": "eng",
          "@value": "Description of a Dataset ",
        },
        "rdf:description":
          "Triples in revision 1 but not in current dataset version",
      },
      null,
      2
    );
    const navigateToDatasetDiffDetails = (): void => {
      router.push({
        name: "DatasetDiffDetails",
        state: {
          oldVersion: oldVersion,
          newVersion: newVersion,
        },
      });
    };

    return {
      dropdownVisible,
      toggleDropdown,
      onSelectionChange,
      selectedLabel,
      publicationText,
      otherVersionText,
      navigateToDatasetDiffDetails,
    };
  },
});

export default DatasetRevisionContainer;
</script>

<style scoped lang="scss">
.revision-container {
  // display: flex;
  background-color: #f3f6fc;
}
.revision-container h6 {
  font-size: 1.1rem;
  margin-bottom: 0.5rem;
  color: #2c3e50;
}
.cmp-text {
  font-size: 1.1rem;
  margin-bottom: 0.5rem;
  color: #0e47cb;
}
p {
  margin: 0.5rem 0 0;
  font-size: 0.875rem;
}
.dropdown-container {
  margin-top: 1rem;
  display: flex;
  flex-direction: column;
  gap: 0.5rem;
}
.dropdown-container p {
  font-size: 0.95rem;
}
.version-dropdown {
  width: 100%;
  padding: 0.5rem;
  font-size: 1rem;
  border: 1px solid #ccc;
  border-radius: 4px;
  background-color: #fff;
  color: #2c3e50;
  appearance: none;
}
.ec-sort-dropdown {
  width: 300px;
  height: 48px;
}
.ec-ds-dropdown-items {
  width: 300px;
  background-color: #fff !important;
  color: #7f7f7f !important;
}
</style>
